#ifndef XSTACK_H
#define XSTACK_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006-2010 Smithsonian Astrophysical Observatory
 *
 * This file is part of aperture
 *
 * aperture is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * -->8-->8-->8-->8-- */

#include "xmatrix.h"

typedef enum {

    intrinsic  = 0,
    extrinsic = 1

} CoordTransform;

void xstack_free( void );
void xstack_check( void );
int  xstack_pop(int empty_is_fatal );
void xstack_push( XMatrix mat );
void xstack_update( XMatrix mat, CoordTransform transform_type );

XMatrix  xstack_get_CTM( void );

void xstack_print_stack( void );
void xstack_print_top( int inverse );
XMatrix xstack_top_copy( void );



#endif /* !XSTACK_H */
