// -*-c++-*-
/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2013 Smithsonian Astrophysical Observatory
 *
 * This file is part of bp-save-history
 *
 * bp-save-history is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * -->8-->8-->8-->8-- */

#ifndef FIELD_H
#define FIELD_H

#include <string>
#include <list>
#include <boost/shared_ptr.hpp>

#include <bpipe/bpipe.h>

class Field {

public:

    boost::shared_ptr<BPMatrix>   copy_matrix;
    DpktField*  dpktf;
    BPDataType  datatype;
    char*       data;
    char*       src;
    size_t      datatype_size;

    Field( BPipe* bpipe, std::string& name );
    Field( DpktField* dpktf );

    void set_data( void* core_image );
    void copy_data( );

private :

    void _init( );
    void _extend( );

};


std::list<Field> gen_fields( BPipe* bpipe, list<string>& field_names );

#endif // ! FIELD_H
