#include <bpipexx/bpipexx.h>


using namespace SAOTrace;

using namespace SAOTrace::BPipeX;

int main( ) {

    BPipeX::Simple bp( "stdin", "stdout" );

    DVector3 v = { 1, 2, 3 };
    bp.add( HdrF<DVector3>( "DVector3", v ) );

    bp.delete_dpktf( "ifoo" );

    bp.add( DpktF<unsigned int>("uifoo") );
    bp.add( DpktF<DVector3>("dv3foo") );
    bp.map();
    bp.write_hdr();

    int* ifoo           = bp.dpktf_data<int>( "ifoo" );
    double* dfoo        = bp.dpktf_data<double>( "dfoo" );
    unsigned int* uifoo = bp.dpktf_data<unsigned int>( "uifoo" );
    DVector3*    dv3foo = bp.dpktf_data<DVector3>( "dv3foo" );

    bp.read_dpkts();

    *dfoo = 3.14;
    *uifoo = *ifoo + 23;
    *dv3foo = v;
    dv3foo->x = *dfoo;

    bp.write_dpkts();

    return 0;
}


