#include <bpipexx/bpipexx.h>

#include <gtest/gtest.h>

using namespace SAOTrace;

using namespace SAOTrace::BPipeX;

class DpktFTest : public ::testing::Test {

protected:

    virtual void SetUp() {

	bp = new BPipeX::Simple;
	bp->add( DpktF<int>("ifoo") );

    }

    virtual void TearDown() {

	delete bp;

    }

    BPipeX::Simple *bp;

};

TEST_F(DpktFTest, DuplicateSameType) {

    ASSERT_NO_THROW( bp->add( DpktF<int>("ifoo") ) );

}

TEST_F(DpktFTest,DuplicateDifferentType) {

    ASSERT_THROW( bp->add( DpktF<double>("ifoo") ), Exception  );

}


TEST_F(DpktFTest,has_dpktf) {

    ASSERT_TRUE( bp->has_dpktf( "ifoo" ) );

    ASSERT_FALSE( bp->has_dpktf("no i don't!") );

}
