#include <bpipexx/bpipexx.h>

#include <gtest/gtest.h>

using namespace SAOTrace;

using namespace SAOTrace::BPipeX;

class HdrFTest : public ::testing::Test {

protected:

    virtual void SetUp() {

	bp = new BPipeX::Simple;
	bp->add( HdrF<int>("ifoo", 3 ) );

    }

    virtual void TearDown() {

	delete bp;

    }

    BPipeX::Simple *bp;

};

TEST_F(HdrFTest, Exists) {

    ASSERT_NO_THROW( bp->hdrf_data<int>( "ifoo" ) );
    ASSERT_NO_THROW( bp->hdrf_data<int>( "ifoo", 0 ) );
    ASSERT_THROW( bp->hdrf_data<int>( "ifoo", 3 ), Exception );

}

TEST_F(HdrFTest, NonExistentField) {

    ASSERT_THROW( bp->hdrf_data<double>( "dfoo"), Exception  );

}

TEST_F(HdrFTest,has_hdrf) {

    ASSERT_TRUE( bp->has_hdrf( "ifoo" ) );

    ASSERT_FALSE( bp->has_hdrf("no i don't!") );

}

