// -*-C++-*-

// --8<--8<--8<--8<--
//
// Copyright (C) 2011 Smithsonian Astrophysical Observatory
//
// This file is part of bpmanip
//
// bpmanip is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// -->8-->8-->8-->8--


#ifndef BPMANIP_FIELDS_H
#define BPMANIP_FIELDS_H


#include <vector>
#include <string>

#include "Wildmat.h"

class Fields {


public:
    Fields() {};
    Fields( std::vector< std::string>& inc, std::vector< std::string>& exc );

    std::vector< std::string > allowed( std::vector< std::string >& fields );
    std::vector< std::string > rejected( std::vector< std::string >& input_fields );

private:
    std::vector< Wildmat > include;
    std::vector< Wildmat > exclude;

};


#endif // !  BPMANIP_FIELDS_H
