// -*-C++-*-

// --8<--8<--8<--8<--
//
// Copyright (C) 2011 Smithsonian Astrophysical Observatory
//
// This file is part of bpmanip
//
// bpmanip is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// -->8-->8-->8-->8--

#ifndef BPMANIP_WILDMAT_H
#define BPMANIP_WILDMAT_H

#include <iostream>
#include <string>
#include <vector>

class Wildmat : public std::binary_function<Wildmat, std::string, bool> {

public:
    Wildmat() {}
    Wildmat( std::string pattern ) : pattern(pattern) {}

    bool operator== ( const std::string& text ) const;

    bool operator() (const Wildmat& pattern, const std::string& text ) const {
	return pattern == text;
    };

private:
    std::string pattern;


};

inline bool operator== ( const std::string& text, const Wildmat& pattern ) {

    return pattern == text;
}


struct WildmatV : public std::binary_function<std::vector<Wildmat>, std::string, bool> {

    WildmatV() {}

    bool operator() (const std::vector<Wildmat>& patterns, const std::string& text ) const;


};

#endif // ! BPMANIP_WILDMAT_H
