module( ..., package.seeall )

local os = require( 'os' )
local srcdir = os.getenv('srcdir') or '.'

local load_sources = require( 'chandra.saotrace.raygen.source' ).load_sources

function srcfile( name )

   return table.concat( { srcdir, 'data', name}, '/' )..'.xml'

end

function setup ()
   _G.setup()
   saotrace.raygen.intrinsic.stash = {}
end


function test_load_it( )

   local ok, msg = pcall( load_sources, srcfile('ngc2516'), {  ra_aimpt = 100,
							       dec_aimpt = 20,
							       scale = 111,
							    }  )

   assert_true( ok, msg )

end

function test_load_it_fail( )

   local ok, msg = pcall( load_sources, srcfile('ngc2516') )

   assert_false( ok, msg )
   assert_match( "must specify", msg )

end
