require 'lunatest'
require 'strict'
local system = require( 'saotrace.raygen.system' )

va = require('validate.args')

function setup() 

   getmetatable( require('saotrace.config') ).reset()
   va.reset()
   va.opts{ check_spec = true,
	    error_on_bad_spec = true,
	 }

   require('saotrace.raygen.intrinsic').stash = {}
   system.reset_nsources()

end

tests = {
   'position',
   'source',
   'jitter',
   'focus',
   'simple',
   'load_sources',
}

for _, v in pairs(tests) do
   lunatest.suite( v )
end

lunatest.run()
