// -*-c++-*-

#ifndef CXCPARAMX_SIMPLE_H
#define CXCPARAMX_SIMPLE_H

#include <memory>
#include <string>

#include <Exception/Exception.h>

namespace cxcparamx {

    class simple {

    public:

	simple( int argc,  char** argv, const char* mode = "rw" );
	simple( const char* filename, int argc, char** argv, const char* mode = "rw" );
	simple( const std::string& filename, int argc, char** argv, const char*mode = "rw" );
	~simple();

	void get( const char* name, float& value );
	void get( const char* name, double& value );
	void get( const char* name, short& value );
	void get( const char* name, int& value );
	void get( const char* name, long& value );
	void get( const char* name, bool& value );
	void get( const char* name, std::string& value );

	float  getf( const char* name );
	double getd( const char* name );
	short  gets( const char* name );
	int    geti( const char* name );
	long   getl( const char* name );
	bool   getb( const char* name );
	std::string getstr( const char* name );

   private:

	simple( simple& );
	simple& operator=( simple& );

	struct ParamFile;

	typedef std::auto_ptr<ParamFile> pParamFile;

	void _init_parfile( const char* filename, int argc, char** argv, const char* mode );
	pParamFile parfile;

	std::string filename;
    };

}

#endif // ! CXCPARAMX_SIMPLE_H
