// --8<--8<--8<--8<--
//
// Copyright (C) 2012 Smithsonian Astrophysical Observatory
//
// This file is part of imageblur
//
// imageblur is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// -->8-->8-->8-->8--

#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

#include "images.h"


#define SIZE 100
#define NPIX (SIZE*SIZE)

long extent[2] = { SIZE, SIZE };


void
create_sequence_image( ) {

    vector<double> image(NPIX);

    fill( image.begin(), image.end(), 1 );

    partial_sum( image.begin(), image.end(), image.begin() );

    write_image( "sequence.fits", image, extent );
}


int main( ) {

    create_sequence_image();

    return 0;
}


