/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2012 Smithsonian Astrophysical Observatory
 *
 * This file is part of imageblur
 *
 * imageblur is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * -->8-->8-->8-->8-- */

#ifndef IMAGES_H
#define IMAGES_H

#include <string>
#include <vector>

void get_image_info( std::string filename, long* extent );
void write_image( std::string filename, std::vector<double>& image, long* extent );
void normalize_image( std::vector<double>& image, double denom = 0 );
std::vector<double>& read_image( std::string filename );


#endif // !IMAGES_H
