#include <string>
#include <iostream>

#include <lua.hpp>
#include <lauxlib.h>

#include "gtest/gtest.h"
#include "t_utils.h"

#include "lua_interface.h"
#include "sysconf.h"

using namespace std;


class StackTest : public testing::Test {

protected:

    lua_State *L;

    virtual void SetUp() {

	L = init_lua("", "");
    }

    virtual void TearDown() {

	cleanup_lua( L );

    }
};



TEST_F( StackTest, config_jitter ) {

    int err = luaL_dostring( L, "require( 'saotrace.config' )" );
    ASSERT_EQ( 0, err ) << lua_tostring(L, -1 );

    SysConf conf( L, "saotrace.config.raygen" );

    EXPECT_TRUE( conf.get_bool("jitter.tintersect") );

}
