require('Test.More')
local rdb = require('rdb')

plan(7)

local table = require('table')
local top_srcdir = require('os').getenv('top_srcdir') or '.'

local db = table.concat( { top_srcdir, 'tests', 'data', 'foo.rdb'}, '/' )

rows, vars = rdb.slurp ( db )

is_deeply( vars, { node = "0" }, "variables"  )

is( #rows, 778, "number of rows" )

exp = {

   {
       mirror = 'p73',
           x0 = 0,
           y0 = 0,
           z0 = -125,
            p = 0,
            k = -32.1360843528092,
         rho0 = 1607.50927388591,
       theta0 = 0,
       az_mis = 0,
       el_mis = 0,
            l = 200,
          z_f = -225,
          z_a = -25,
        rho_f = 1609.50715515644,
        rho_a = 1605.50890647131
   },


   {
       mirror = 'h73',
           x0 = 0,
           y0 = 0,
           z0 = nil,
            p = -0.00321360429346925,
            k = -96.1097423441621,
         rho0 = 1597.49003013772,
       theta0 = 0,
       az_mis = 0,
       el_mis = 0,
            l = 200,
          z_f = 25,
          z_a = 225,
        rho_f = 1603.50506107695,
        rho_a = 1591.47245780809,
   },

   {
       mirror = nil,
           x0 = 0,
           y0 = 0,
           z0 = -125,
            p = 0,
            k = -31.9368863570267,
         rho0 = 1602.50946325736,
       theta0 = 0,
       az_mis = 0,
       el_mis = 0,
            l = 200,
          z_f = -225,
          z_a = -25,
        rho_f = 1604.50115521955,
        rho_a = 1600.51529282222,
   },

   {
       mirror = 'h74',
           x0 = 0,
           y0 = 0,
           z0 = 125,
            p = -0.00319368457039678,
            k = -95.5133635348477,
         rho0 = 1592.52130787559,
       theta0 = 0,
       az_mis = 0,
       el_mis = 0,
            l = 200,
          z_f = 25,
          z_a = 225,
        rho_f = 1598.5176650847,
        rho_a = nil,
   },

   {
       mirror = 'h461',
           x0 = 0,
           y0 = 0,
           z0 = 125,
            p = -0.000171333208598343,
            k = -5.1188731637833,
         rho0 = 368.508954833481,
       theta0 = 0,
       az_mis = 0,
       el_mis = 0,
            l = 200,
          z_f = 25,
          z_a = 225,
        rho_f = 369.897739591506,
        rho_a = 367.119583364142
   },
}

for i = 1,#exp-1 do
   is_deeply( exp[i], rows[i], "row " .. i )
end

is_deeply( exp[#exp], rows[#rows], "row n" )
