#include <tracefct/tracefct.h>

#include "main.h"
#include "common.h"

#include "core_image_dump.h"

void
core_image_dump(
  CoreWeight *fpix,
  size_t npix,
  long min_i,
  long max_i,
  FILE *fimage
)
{
  CoreWeight *pix;
  long i;

  tf_enter("core_image_dump");

  c.dump->setup(fimage, CORE, min_i, max_i, 0, 0);

  for (pix = fpix, i = min_i ; i <= max_i ; i++)
  {
    size_t n;
    long min_j, max_j;

    c.backend->j_image_limits(i, 0, 0, &min_j, &max_j);

    n = max_j - min_j + 1;

    c.dump->start_i(i, n);
    c.dump->write_pix(pix, min_j, n);
    c.dump->end_i();

    pix += n;
  }

  c.dump->cleanup();

  tf_leave();
}
