#include <stdio.h>

#include <rbtree/rbtree.h>
#include <suplib/debug.h>

#include "main.h"
#include "debug.h"

CoreWeight wt;
unsigned long num_zero, num_pix;

void
dump_wts(Jnode *jn)
{
  long j;

  for (j = jn->j_min ; j <= jn->j_max ; j++)
    fprintf(stderr, "%f ", jn->wt[j - jn->j_min]);
  fprintf(stderr, "\n");
}

int
print_jnode(void *nd)
{
  Jnode *jnode = nd;

  fprintf(stderr, "    j: %ld %ld\n", jnode->j_min, jnode->j_max);
  if (dbflag("dump_wts"))
  {
    fprintf(stderr, "     ");
    dump_wts(jnode);
  }
  return 0;
}

int
print_inode(void *nd)
{
  Inode *inode = nd;

  fprintf(stderr, "  i: %ld\n", inode->i);
  rbtree_traverse(inode->j, print_jnode, LEFT_TO_RIGHT);
  return 0;
}

void
tree_dump(RBTree Itree)
{
  rbtree_traverse(Itree, print_inode, LEFT_TO_RIGHT);
}


int
wt_jnode(void *nd)
{
  Jnode *jn = nd;
   int j;

  for (j = jn->j_min ; j <= jn->j_max ; j++)
    wt += jn->wt[j - jn->j_min];

  return 0;
}

int
wt_inode(void *nd)
{
  Inode *inode = nd;

  rbtree_traverse(inode->j, wt_jnode, LEFT_TO_RIGHT);
  return 0;
}

CoreWeight
tree_wt(RBTree Itree)
{
  wt = 0.0;
  rbtree_traverse(Itree, wt_inode, LEFT_TO_RIGHT);
  return wt;
}


int
efficiency_jnode(void *nd)
{
  Jnode *jn = nd;
   int j;

  for (j = jn->j_min ; j <= jn->j_max ; j++)
  {
    num_pix++;
    if (! jn->wt[j - jn->j_min]) num_zero++;
  }

  return 0;
}

int
efficiency_inode(void *nd)
{
  Inode *inode = nd;

  rbtree_traverse(inode->j, efficiency_jnode, LEFT_TO_RIGHT);
  return 0;
}

void
tree_efficiency(RBTree Itree)
{
  num_zero = num_pix = 0;
  rbtree_traverse(Itree, efficiency_inode, LEFT_TO_RIGHT);
  fprintf(stderr, "num_pix: %ld num_zero: %ld ratio: %f\n", num_pix, num_zero,
	  num_zero / (double) num_pix);
}

