#ifndef READBPIPE_H
#define READBPIPE_H

#include <bpipe/bpipe.h>
#include <bpipe/bpipe_axaf.h>
#include <bpipe/datatypes.h>

typedef struct {
  void *bpipe;
  void *data;
  BPipeOutput *outstream;
} Bpipe;

typedef struct {
  double   *x;
  double   *y;
  double   *z;
  double    z_dummy; /* a throw away storage spot if z doesn't exist
			in input bpipe */
			
  double   *weight;
} BpipePhoton;

void init_bpipe( char* input, char* output, Bpipe* pipe, BpipePhoton* photon );

#endif


