#ifndef SPATQUANT_H
#define SPATQUANT_H

typedef enum
{
  ImageFormat_MATRIX_ASCII_HDR,
  ImageFormat_MATRIX_ASCII_RAW,
  ImageFormat_MATRIX_BINARY_HDR,
  ImageFormat_MATRIX_BINARY_RAW,
  ImageFormat_MATRIX_RDB
} ImageFormat;

typedef enum
{
  exponent,
  discrete,
  rdbfile,
  linear
} WedgeFormat;

typedef enum
{
  BackEnd_RectRect,
  BackEnd_HexCirc,
  BackEnd_RectCirc,
  BackEnd_Wedge
} BackEndType;

typedef struct {

  int type;
  int Nwedge;
  double constant;
  double base;
  double Rmax;
  double Tmin;

} WedgeImage;

typedef struct
{
  int ni, nj;
  int i_min, j_min;
  double x0, y0;
  double x_sz, y_sz;  
} RectRectImage;

typedef struct
{
  int ni, nj;
  int i_min, j_min;
  double x0, y0;
  double diameter, spacing;
  double x_sp, y_sp;  
} HexCircImage;

typedef struct
{
  int ni, nj;
  int i_min, j_min;
  double x0, y0;
  double diameter;
  double x_sp, y_sp;  
} RectCircImage;

#endif /* SPATQUANT_H */
