#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <tracefct/exiterrvals.h>
#include <suplib/str.h>
#include <tracefct/tracefct.h>

#include "wedge.h"

AnnuliLinear* read_wedge_linear( char str[] ) {

  AnnuliLinear* annuli=NULL;
  char** annuli_linear_tokens=NULL;
  int num_tokens=0;

  tf_enter( "read_wedge_linear" );

  annuli = (AnnuliLinear*) malloc( sizeof( AnnuliLinear ) );
  if ( NULL == annuli )
    tf_exit( ExitERR_alloc, "Unable to allocate memory for annuli" );

  num_tokens = str_tokenize( str, ",", &annuli_linear_tokens, 1, 1 );
  if ( 3 != num_tokens )
    tf_exit( ExitERR_illegalArg, "Illegal entry `%s', expected 3 tokens",
	     str );

  if ( EXIT_FAILURE == str2d( annuli_linear_tokens[ 0 ],
			      &(annuli->deltaR) ) )
    tf_exit( ExitERR_illegalArg, "Illegal entry `%s' for the constant",
	     annuli_linear_tokens[ 0 ] );

  if ( EXIT_FAILURE == str2i( annuli_linear_tokens[ 1 ],
			      &(annuli->num_wedges) ) )
    tf_exit( ExitERR_illegalArg, "Illegal entry `%s' for the number of wedges",
	     annuli_linear_tokens[ 1 ] );

  calculate_wedges( &(annuli->wedge), annuli_linear_tokens[ 2 ],
		    annuli->num_wedges );

  /* print_AnnuliLinear( stderr, annuli ); */

  str_tokenize_free( annuli_linear_tokens, 1 );
  tf_leave( );

  return annuli;

}
